<?php

namespace App\Http\Controllers;

use App\Models\CredencialProfesional;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class CredencialProfesionalController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = CredencialProfesional::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new CredencialProfesional())->getFillable());
        $credencialProfesional = CredencialProfesional::create($payload);

        return response()->json([
            'success' => true,
            'data' => $credencialProfesional,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(CredencialProfesional $credencialProfesional): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $credencialProfesional,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, CredencialProfesional $credencialProfesional): JsonResponse
    {
        $payload = $request->only((new CredencialProfesional())->getFillable());
        $credencialProfesional->update($payload);

        return response()->json([
            'success' => true,
            'data' => $credencialProfesional,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(CredencialProfesional $credencialProfesional): JsonResponse
    {
        $credencialProfesional->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}